.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000		; 1000000 would be a typical value

; frktons 19.4.2010

.data
src	db "12345678901234567890123456789012345678901234567890123456789012345678901234567890"
tgt_desired	db "1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 "
tgt	db "xxxxxxxx"
	REPEAT 19
	db "xxxxxxxx"
	ENDM
	db 0, "Little test if we overwrite the buffer: put REPEAT 18 instead of 19...", 0
src4	db 4000 dup ('A')
tgt8	db 8000 dup('*'),0

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	invoke Sleep, 200
	counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS
	mov ecx, 1000
	mov esi, offset src4
	mov edi, offset tgt8
	.Repeat
		mov eax, [esi]
		mov [edi], al
		mov [edi+2], ah
		bswap eax
		mov [edi+6], al
		mov [edi+4], ah
		add esi, 4
		add edi, 8
		dec ecx
	.Until Zero?
	counter_end
	print str$(eax), 9, "cycles for bswap 4k", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, sizeof src/4
		mov esi, offset src
		mov edi, offset tgt
		a1s:
		.Repeat
			dec ecx
			mov eax, [esi+4*ecx]
			mov [edi+8*ecx], al
			mov [edi+2+8*ecx], ah
			bswap eax
			mov [edi+4+8*ecx], ah
			mov [edi+6+8*ecx], al
		.Until Zero?
		a1e:
	counter_end
	print str$(eax), 9, "cycles for bswap A", 9
	mov eax, a1e
	sub eax, a1s
	print str$(eax), " bytes", 13, 10
;	print offset tgt, 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, sizeof src/4
		mov esi, offset src
		mov edi, offset tgt
		a2s:
		.Repeat
			mov eax, [esi]
			mov [edi], al
			mov [edi+2], ah
			bswap eax
			mov [edi+4], ah
			mov [edi+6], al
			add esi, 4
			add edi, 8
			dec ecx
		.Until Zero?
		a2e:
	counter_end
	print str$(eax), 9, "cycles for bswap B", 9
	mov eax, a2e
	sub eax, a2s
	print str$(eax), " bytes", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, sizeof src/4
		mov esi, offset src
		mov edi, offset tgt
		a3s:
		.Repeat
			movzx eax, word ptr [esi]
			mov [edi], al
			mov [edi+2], ah
			movzx eax, word ptr [esi+2]
			mov [edi+4], al
			mov [edi+2+4], ah
			add esi, 4
			add edi, 8
			dec ecx
		.Until Zero?
		a3e:
	counter_end
	print str$(eax), 9, "cycles for word read", 9
	mov eax, a3e
	sub eax, a3s
	print str$(eax), " bytes", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, sizeof src/4
		mov esi, offset src
		mov edi, offset tgt
		a4s:
		.Repeat
			mov eax, [esi]
			mov [edi], al
			shr eax, 8
			mov [edi+2], al
			shr eax, 8
			mov [edi+4], al
			shr eax, 8
			mov [edi+6], al
			add esi, 4
			add edi, 8
			dec ecx
		.Until Zero?
		a4e:
	counter_end
	print str$(eax), 9, "cycles for shr eax, A", 9
	mov eax, a4e
	sub eax, a4s
	print str$(eax), " bytes", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, sizeof src/4
		mov esi, offset src
		mov edi, offset tgt
		a5s:
		.Repeat
			mov eax, [esi]
			mov [edi], al
			shr eax, 8
			add edi, 2
			mov [edi], al
			shr eax, 8
			add edi, 2
			mov [edi], al
			shr eax, 8
			add edi, 2
			mov [edi], al
			add edi, 2
			add esi, 4
			dec ecx
		.Until Zero?
		a5e:
	counter_end
	print str$(eax), 9, "cycles for shr eax, B", 9
	mov eax, a5e
	sub eax, a5s
	print str$(eax), " bytes", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, sizeof src/4
		mov esi, offset src
		mov edi, offset tgt
		a6s:
		.Repeat
			lodsd
			mov [edi], al
			mov [edi+2], ah
			bswap eax
			mov [edi+6], al
			mov [edi+4], ah
			lea edi, [edi+8]		; here: one cycle faster than add
			dec ecx
		.Until Zero?
		a6e:
	counter_end
	print str$(eax), 9, "cycles for lodsd+bsw A", 9
	mov eax, a6e
	sub eax, a6s
	print str$(eax), " bytes", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset tgt
		a7s:
		.Repeat
			lodsd
			stosb
			inc edi
			mov [edi], ah
			bswap eax
			mov [edi+2], ah
			mov [edi+4], al
			add edi, 6
		.Until edi>=offset tgt+sizeof src*2
		a7e:
	counter_end
	print str$(eax), 9, "cycles for lodsd+bsw B", 9
	mov eax, a7e
	sub eax, a7s
	print str$(eax), " bytes", 13, 10, 10

	print offset tgt
	getkey
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

OPT_Tmp2Asm	1
OPT_Wait	0
OPT_Res	0
OPT_Linker	polink
